From 6ea3c4ed2337dbfcbb88ab29c05bbd7d5b6f6b30 Mon Sep 17 00:00:00 2001
From: Augustin Cavalier <waddlesplash@gmail.com>
Date: Tue, 8 Apr 2025 16:38:13 -0400
Subject: [PATCH] WIP: libroot/glibc: Synchronize libio with upstream glibc
 2.20.

Includes changes/adjustments for integration with Haiku's libroot
as well as C89 fixes for GCC2 compatibility. Also imports one
patch from glibc trunk to fix ungetc+fflush behavior.

Fixes #19039.

Change-Id: I73ebde80d314460174d344ba1e2960807ad4717b

2	0	src/system/libroot/posix/glibc/include/bits/libc-lock.h
13	5	src/system/libroot/posix/glibc/include/bits/stdio-lock.h
55	34	src/system/libroot/posix/glibc/include/bits/stdio.h
3	0	src/system/libroot/posix/glibc/include/fcntl.h
169	24	src/system/libroot/posix/glibc/include/misc/sys/cdefs.h
54	0	src/system/libroot/posix/glibc/include/not-cancel.h
1	0	src/system/libroot/posix/glibc/include/string.h
0	2	src/system/libroot/posix/glibc/libio/Jamfile
1	14	src/system/libroot/posix/glibc/libio/_G_config.h
3	4	src/system/libroot/posix/glibc/libio/__fbufsize.c
3	4	src/system/libroot/posix/glibc/libio/__flbf.c
3	4	src/system/libroot/posix/glibc/libio/__fpending.c
5	6	src/system/libroot/posix/glibc/libio/__fpurge.c
3	4	src/system/libroot/posix/glibc/libio/__freadable.c
2	2	src/system/libroot/posix/glibc/libio/__freading.c
4	5	src/system/libroot/posix/glibc/libio/__fsetlocking.c
3	4	src/system/libroot/posix/glibc/libio/__fwritable.c
3	4	src/system/libroot/posix/glibc/libio/__fwriting.c
3	4	src/system/libroot/posix/glibc/libio/clearerr.c
3	4	src/system/libroot/posix/glibc/libio/clearerr_u.c
3	6	src/system/libroot/posix/glibc/libio/fcloseall.c
3	4	src/system/libroot/posix/glibc/libio/feof.c
3	4	src/system/libroot/posix/glibc/libio/feof_u.c
3	4	src/system/libroot/posix/glibc/libio/ferror.c
3	4	src/system/libroot/posix/glibc/libio/ferror_u.c
20	12	src/system/libroot/posix/glibc/libio/filedoalloc.c
3	4	src/system/libroot/posix/glibc/libio/fileno.c
408	372	src/system/libroot/posix/glibc/libio/fileops.c
18	11	src/system/libroot/posix/glibc/libio/flockfile.c
35	17	src/system/libroot/posix/glibc/libio/fmemopen.c
5	8	src/system/libroot/posix/glibc/libio/fputc.c
3	4	src/system/libroot/posix/glibc/libio/fputc_u.c
6	9	src/system/libroot/posix/glibc/libio/fputwc.c
4	5	src/system/libroot/posix/glibc/libio/fputwc_u.c
63	31	src/system/libroot/posix/glibc/libio/freopen.c
5	8	src/system/libroot/posix/glibc/libio/fseek.c
9	8	src/system/libroot/posix/glibc/libio/fseeko.c
12	10	src/system/libroot/posix/glibc/libio/ftello.c
18	25	src/system/libroot/posix/glibc/libio/fwide.c
4	4	src/system/libroot/posix/glibc/libio/fwprintf.c
6	5	src/system/libroot/posix/glibc/libio/fwscanf.c
235	160	src/system/libroot/posix/glibc/libio/genops.c
5	8	src/system/libroot/posix/glibc/libio/getc.c
3	6	src/system/libroot/posix/glibc/libio/getc_u.c
6	10	src/system/libroot/posix/glibc/libio/getchar.c
4	5	src/system/libroot/posix/glibc/libio/getchar_u.c
5	8	src/system/libroot/posix/glibc/libio/getwc.c
4	5	src/system/libroot/posix/glibc/libio/getwc_u.c
6	10	src/system/libroot/posix/glibc/libio/getwchar.c
4	5	src/system/libroot/posix/glibc/libio/getwchar_u.c
12	18	src/system/libroot/posix/glibc/libio/iofclose.c
42	28	src/system/libroot/posix/glibc/libio/iofdopen.c
7	10	src/system/libroot/posix/glibc/libio/iofflush.c
23	9	src/system/libroot/posix/glibc/libio/iofgetpos.c
14	9	src/system/libroot/posix/glibc/libio/iofgets.c
13	6	src/system/libroot/posix/glibc/libio/iofgets_u.c
13	8	src/system/libroot/posix/glibc/libio/iofgetws.c
12	5	src/system/libroot/posix/glibc/libio/iofgetws_u.c
14	12	src/system/libroot/posix/glibc/libio/iofopen.c
61	37	src/system/libroot/posix/glibc/libio/iofopncook.c
6	10	src/system/libroot/posix/glibc/libio/iofputs.c
3	4	src/system/libroot/posix/glibc/libio/iofputs_u.c
5	8	src/system/libroot/posix/glibc/libio/iofputws.c
3	4	src/system/libroot/posix/glibc/libio/iofputws_u.c
7	10	src/system/libroot/posix/glibc/libio/iofread.c
4	5	src/system/libroot/posix/glibc/libio/iofread_u.c
22	8	src/system/libroot/posix/glibc/libio/iofsetpos.c
9	12	src/system/libroot/posix/glibc/libio/ioftell.c
83	59	src/system/libroot/posix/glibc/libio/iofwide.c
12	11	src/system/libroot/posix/glibc/libio/iofwrite.c
8	5	src/system/libroot/posix/glibc/libio/iofwrite_u.c
20	13	src/system/libroot/posix/glibc/libio/iogetdelim.c
34	39	src/system/libroot/posix/glibc/libio/iogetline.c
7	11	src/system/libroot/posix/glibc/libio/iogets.c
5	10	src/system/libroot/posix/glibc/libio/iogetwline.c
62	68	src/system/libroot/posix/glibc/libio/iolibio.h
4	5	src/system/libroot/posix/glibc/libio/iopadn.c
160	78	src/system/libroot/posix/glibc/libio/iopopen.c
21	25	src/system/libroot/posix/glibc/libio/ioputs.c
15	14	src/system/libroot/posix/glibc/libio/ioseekoff.c
31	32	src/system/libroot/posix/glibc/libio/ioseekpos.c
7	10	src/system/libroot/posix/glibc/libio/iosetbuffer.c
7	10	src/system/libroot/posix/glibc/libio/iosetvbuf.c
6	9	src/system/libroot/posix/glibc/libio/ioungetc.c
7	10	src/system/libroot/posix/glibc/libio/ioungetwc.c
17	18	src/system/libroot/posix/glibc/libio/iovdprintf.c
8	15	src/system/libroot/posix/glibc/libio/iovsprintf.c
6	10	src/system/libroot/posix/glibc/libio/iovsscanf.c
5	9	src/system/libroot/posix/glibc/libio/iovswscanf.c
3	4	src/system/libroot/posix/glibc/libio/iowpadn.c
68	72	src/system/libroot/posix/glibc/libio/libio.h
371	427	src/system/libroot/posix/glibc/libio/libioP.h
24	105	src/system/libroot/posix/glibc/libio/memstream.c
3	4	src/system/libroot/posix/glibc/libio/pclose.c
5	8	src/system/libroot/posix/glibc/libio/peekc.c
6	9	src/system/libroot/posix/glibc/libio/putc.c
3	4	src/system/libroot/posix/glibc/libio/putc_u.c
5	9	src/system/libroot/posix/glibc/libio/putchar.c
3	4	src/system/libroot/posix/glibc/libio/putchar_u.c
5	8	src/system/libroot/posix/glibc/libio/putwc.c
3	4	src/system/libroot/posix/glibc/libio/putwc_u.c
5	9	src/system/libroot/posix/glibc/libio/putwchar.c
3	4	src/system/libroot/posix/glibc/libio/putwchar_u.c
5	8	src/system/libroot/posix/glibc/libio/rewind.c
4	5	src/system/libroot/posix/glibc/libio/setbuf.c
4	5	src/system/libroot/posix/glibc/libio/setlinebuf.c
10	11	src/system/libroot/posix/glibc/libio/stdfiles.c
4	10	src/system/libroot/posix/glibc/libio/stdio.c
471	208	src/system/libroot/posix/glibc/libio/stdio.h
25	5	src/system/libroot/posix/glibc/libio/strfile.h
126	86	src/system/libroot/posix/glibc/libio/strops.c
6	6	src/system/libroot/posix/glibc/libio/swprintf.c
6	5	src/system/libroot/posix/glibc/libio/swscanf.c
12	14	src/system/libroot/posix/glibc/libio/vasprintf.c
4	8	src/system/libroot/posix/glibc/libio/vscanf.c
17	31	src/system/libroot/posix/glibc/libio/vsnprintf.c
16	29	src/system/libroot/posix/glibc/libio/vswprintf.c
6	7	src/system/libroot/posix/glibc/libio/vwprintf.c
5	7	src/system/libroot/posix/glibc/libio/vwscanf.c
14	32	src/system/libroot/posix/glibc/libio/wfiledoalloc.c
404	218	src/system/libroot/posix/glibc/libio/wfileops.c
36	42	src/system/libroot/posix/glibc/libio/wgenops.c
6	5	src/system/libroot/posix/glibc/libio/wprintf.c
6	5	src/system/libroot/posix/glibc/libio/wscanf.c
125	87	src/system/libroot/posix/glibc/libio/wstrops.c
1	1	src/system/libroot/posix/glibc/wcsmbs/wchar.h

diff --git a/src/system/libroot/posix/glibc/include/bits/libc-lock.h b/src/system/libroot/posix/glibc/include/bits/libc-lock.h
index 4ab2a1aaa8..8b965f5bb6 100644
--- a/src/system/libroot/posix/glibc/include/bits/libc-lock.h
+++ b/src/system/libroot/posix/glibc/include/bits/libc-lock.h
@@ -24,12 +24,14 @@
 #include <stddef.h>
 
 #define __libc_maybe_call(func, args, else) func args
+#define __sched_yield sched_yield
 #define __pthread_mutex_init pthread_mutex_init
 #define __pthread_mutex_destroy pthread_mutex_destroy
 #define __pthread_mutexattr_init pthread_mutexattr_init
 #define __pthread_mutexattr_destroy pthread_mutexattr_destroy
 #define __pthread_mutexattr_settype pthread_mutexattr_settype
 #define __pthread_mutex_lock pthread_mutex_lock
+#define __pthread_mutex_trylock pthread_mutex_trylock
 #define __pthread_mutex_unlock pthread_mutex_unlock
 #define PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP	PTHREAD_RECURSIVE_MUTEX_INITIALIZER
 #define PTHREAD_MUTEX_RECURSIVE_NP	PTHREAD_MUTEX_RECURSIVE
diff --git a/src/system/libroot/posix/glibc/include/bits/stdio-lock.h b/src/system/libroot/posix/glibc/include/bits/stdio-lock.h
index 8d865b63af..198cb67535 100644
--- a/src/system/libroot/posix/glibc/include/bits/stdio-lock.h
+++ b/src/system/libroot/posix/glibc/include/bits/stdio-lock.h
@@ -1,5 +1,5 @@
 /* Thread package specific definitions of stream lock type.  Generic version.
-   Copyright (C) 2000, 2001, 2002 Free Software Foundation, Inc.
+   Copyright (C) 2000-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -13,9 +13,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.  */
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
 
 #ifndef _BITS_STDIO_LOCK_H
 #define _BITS_STDIO_LOCK_H 1
@@ -27,7 +26,7 @@ __libc_lock_define_recursive (typedef, _IO_lock_t)
 /* We need recursive (counting) mutexes.  */
 #ifdef _LIBC_LOCK_RECURSIVE_INITIALIZER
 # define _IO_lock_initializer _LIBC_LOCK_RECURSIVE_INITIALIZER
-#elif defined _IO_MTSAFE_IO
+#elif _IO_MTSAFE_IO
  #error libio needs recursive mutexes for _IO_MTSAFE_IO
 #endif
 
@@ -45,5 +44,14 @@ __libc_lock_define_recursive (typedef, _IO_lock_t)
 #define _IO_cleanup_region_end(_doit) \
   __libc_cleanup_region_end (_doit)
 
+#if defined _LIBC && !defined NOT_IN_libc
+# define _IO_acquire_lock(_fp) \
+  _IO_cleanup_region_start ((void (*) (void *)) _IO_funlockfile, (_fp));      \
+  _IO_flockfile (_fp)
+
+# define _IO_release_lock(_fp) \
+  _IO_funlockfile (_fp);						      \
+  _IO_cleanup_region_end (0)
+#endif
 
 #endif /* bits/stdio-lock.h */
diff --git a/src/system/libroot/posix/glibc/include/bits/stdio.h b/src/system/libroot/posix/glibc/include/bits/stdio.h
index 387da3c4b0..4fd4b845db 100644
--- a/src/system/libroot/posix/glibc/include/bits/stdio.h
+++ b/src/system/libroot/posix/glibc/include/bits/stdio.h
@@ -1,5 +1,5 @@
 /* Optimizing macros and inline functions for stdio functions.
-   Copyright (C) 1998, 2000, 2001 Free Software Foundation, Inc.
+   Copyright (C) 1998-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -13,15 +13,14 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.  */
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
 
 #ifndef _STDIO_H
 # error "Never include <bits/stdio.h> directly; use <stdio.h> instead."
 #endif
 
-#ifdef __cplusplus
+#ifndef __extern_inline
 # define __STDIO_INLINE inline
 #else
 # define __STDIO_INLINE __extern_inline
@@ -29,41 +28,55 @@
 
 
 #ifdef __USE_EXTERN_INLINES
+/* For -D_FORTIFY_SOURCE{,=2} bits/stdio2.h will define a different
+   inline.  */
+# if !(__USE_FORTIFY_LEVEL > 0 && defined __fortify_function)
 /* Write formatted output to stdout from argument list ARG.  */
 __STDIO_INLINE int
-vprintf (__const char *__restrict __fmt, _G_va_list __arg) __THROW
+vprintf (const char *__restrict __fmt, _G_va_list __arg)
 {
   return vfprintf (stdout, __fmt, __arg);
 }
+# endif
 
 /* Read a character from stdin.  */
 __STDIO_INLINE int
-getchar (void) __THROW
+getchar (void)
 {
   return _IO_getc (stdin);
 }
 
 
-# if defined __USE_POSIX || defined __USE_MISC
+# ifdef __USE_MISC
+/* Faster version when locking is not necessary.  */
+__STDIO_INLINE int
+fgetc_unlocked (FILE *__fp)
+{
+  return _IO_getc_unlocked (__fp);
+}
+# endif /* misc */
+
+
+# ifdef __USE_POSIX
 /* This is defined in POSIX.1:1996.  */
 __STDIO_INLINE int
-getc_unlocked (FILE *__fp) __THROW
+getc_unlocked (FILE *__fp)
 {
   return _IO_getc_unlocked (__fp);
 }
 
 /* This is defined in POSIX.1:1996.  */
 __STDIO_INLINE int
-getchar_unlocked (void) __THROW
+getchar_unlocked (void)
 {
   return _IO_getc_unlocked (stdin);
 }
-# endif	/* POSIX || misc */
+# endif	/* POSIX */
 
 
 /* Write a character to stdout.  */
 __STDIO_INLINE int
-putchar (int __c) __THROW
+putchar (int __c)
 {
   return _IO_putc (__c, stdout);
 }
@@ -72,34 +85,34 @@ putchar (int __c) __THROW
 # ifdef __USE_MISC
 /* Faster version when locking is not necessary.  */
 __STDIO_INLINE int
-fputc_unlocked (int __c, FILE *__stream) __THROW
+fputc_unlocked (int __c, FILE *__stream)
 {
   return _IO_putc_unlocked (__c, __stream);
 }
 # endif /* misc */
 
 
-# if defined __USE_POSIX || defined __USE_MISC
+# ifdef __USE_POSIX
 /* This is defined in POSIX.1:1996.  */
 __STDIO_INLINE int
-putc_unlocked (int __c, FILE *__stream) __THROW
+putc_unlocked (int __c, FILE *__stream)
 {
   return _IO_putc_unlocked (__c, __stream);
 }
 
 /* This is defined in POSIX.1:1996.  */
 __STDIO_INLINE int
-putchar_unlocked (int __c) __THROW
+putchar_unlocked (int __c)
 {
   return _IO_putc_unlocked (__c, stdout);
 }
-# endif	/* POSIX || misc */
+# endif	/* POSIX */
 
 
-# ifdef	__USE_GNU
+# if defined(__USE_GNU) && !defined(__HAIKU__)
 /* Like `getdelim', but reads up to a newline.  */
 __STDIO_INLINE _IO_ssize_t
-getline (char **__lineptr, size_t *__n, FILE *__stream) __THROW
+getline (char **__lineptr, size_t *__n, FILE *__stream)
 {
   return __getdelim (__lineptr, __n, '\n', __stream);
 }
@@ -109,14 +122,14 @@ getline (char **__lineptr, size_t *__n, FILE *__stream) __THROW
 # ifdef __USE_MISC
 /* Faster versions when locking is not required.  */
 __STDIO_INLINE int
-feof_unlocked (FILE *__stream) __THROW
+__NTH (feof_unlocked (FILE *__stream))
 {
   return _IO_feof_unlocked (__stream);
 }
 
 /* Faster versions when locking is not required.  */
 __STDIO_INLINE int
-ferror_unlocked (FILE *__stream) __THROW
+__NTH (ferror_unlocked (FILE *__stream))
 {
   return _IO_ferror_unlocked (__stream);
 }
@@ -125,43 +138,51 @@ ferror_unlocked (FILE *__stream) __THROW
 #endif /* Use extern inlines.  */
 
 
-#if defined __USE_MISC && defined __GNUC__ && defined __OPTIMIZE__
+#if defined __USE_MISC && defined __GNUC__ && defined __OPTIMIZE__ \
+    && !defined __cplusplus
 /* Perform some simple optimizations.  */
 # define fread_unlocked(ptr, size, n, stream) \
   (__extension__ ((__builtin_constant_p (size) && __builtin_constant_p (n)    \
-		   && (size_t) ((size) * (n)) <= 8 && (size) != 0)	      \
+		   && (size_t) (size) * (size_t) (n) <= 8		      \
+		   && (size_t) (size) != 0)				      \
 		  ? ({ char *__ptr = (char *) (ptr);			      \
 		       FILE *__stream = (stream);			      \
 		       size_t __cnt;					      \
-		       for (__cnt = (size) * (n); __cnt > 0; --__cnt)	      \
+		       for (__cnt = (size_t) (size) * (size_t) (n);	      \
+			    __cnt > 0; --__cnt)				      \
 			 {						      \
 			   int __c = _IO_getc_unlocked (__stream);	      \
 			   if (__c == EOF)				      \
 			     break;					      \
 			   *__ptr++ = __c;				      \
 			 }						      \
-		       ((size_t) ((size) * (n)) - __cnt) / (size); })	      \
-		  : (((__builtin_constant_p (size) && (size) == 0)	      \
-		      || (__builtin_constant_p (n) && (n) == 0))	      \
+		       ((size_t) (size) * (size_t) (n) - __cnt)		      \
+			/ (size_t) (size); })				      \
+		  : (((__builtin_constant_p (size) && (size_t) (size) == 0)   \
+		      || (__builtin_constant_p (n) && (size_t) (n) == 0))     \
 			/* Evaluate all parameters once.  */		      \
 		     ? ((void) (ptr), (void) (stream), (void) (size),	      \
-			(void) (n), 0)					      \
+			(void) (n), (size_t) 0)				      \
 		     : fread_unlocked (ptr, size, n, stream))))
 
 # define fwrite_unlocked(ptr, size, n, stream) \
   (__extension__ ((__builtin_constant_p (size) && __builtin_constant_p (n)    \
-		   && (size_t) ((size) * (n)) <= 8 && (size) != 0)	      \
+		   && (size_t) (size) * (size_t) (n) <= 8		      \
+		   && (size_t) (size) != 0)				      \
 		  ? ({ const char *__ptr = (const char *) (ptr);	      \
 		       FILE *__stream = (stream);			      \
 		       size_t __cnt;					      \
-		       for (__cnt = (size) * (n); __cnt > 0; --__cnt)	      \
+		       for (__cnt = (size_t) (size) * (size_t) (n);	      \
+			    __cnt > 0; --__cnt)				      \
 			 if (_IO_putc_unlocked (*__ptr++, __stream) == EOF)   \
 			   break;					      \
-		       ((size_t) ((size) * (n)) - __cnt) / (size); })	      \
-		  : (((__builtin_constant_p (size) && (size) == 0)	      \
-		      || (__builtin_constant_p (n) && (n) == 0))	      \
+		       ((size_t) (size) * (size_t) (n) - __cnt)		      \
+			/ (size_t) (size); })				      \
+		  : (((__builtin_constant_p (size) && (size_t) (size) == 0)   \
+		      || (__builtin_constant_p (n) && (size_t) (n) == 0))     \
 			/* Evaluate all parameters once.  */		      \
-		     ? ((void) (ptr), (void) (stream), (void) (size), n)      \
+		     ? ((void) (ptr), (void) (stream), (void) (size),	      \
+			(void) (n), (size_t) 0)				      \
 		     : fwrite_unlocked (ptr, size, n, stream))))
 #endif
 
diff --git a/src/system/libroot/posix/glibc/include/fcntl.h b/src/system/libroot/posix/glibc/include/fcntl.h
index 41b7516a7e..8fbc3c62f8 100644
--- a/src/system/libroot/posix/glibc/include/fcntl.h
+++ b/src/system/libroot/posix/glibc/include/fcntl.h
@@ -3,6 +3,9 @@
 #include_next <fcntl.h>
 #include <features.h>
 
+#define O_LARGEFILE 0
+#define __ASSUME_O_CLOEXEC
+
 /* Now define the internal interfaces.  */
 extern int __open64 (__const char *__file, int __oflag, ...);
 libc_hidden_proto (__open64)
diff --git a/src/system/libroot/posix/glibc/include/misc/sys/cdefs.h b/src/system/libroot/posix/glibc/include/misc/sys/cdefs.h
index f4aa3d76c6..56267df5e0 100644
--- a/src/system/libroot/posix/glibc/include/misc/sys/cdefs.h
+++ b/src/system/libroot/posix/glibc/include/misc/sys/cdefs.h
@@ -1,4 +1,4 @@
-/* Copyright (C) 1992-2001, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1992-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.  */
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
 
 #ifndef	_SYS_CDEFS_H
 #define	_SYS_CDEFS_H	1
@@ -37,33 +36,52 @@
 
 #ifdef __GNUC__
 
+/* All functions, except those with callbacks or those that
+   synchronize memory, are leaf functions.  */
+# if __GNUC_PREREQ (4, 6) && !defined _LIBC
+#  define __LEAF , __leaf__
+#  define __LEAF_ATTR __attribute__ ((__leaf__))
+# else
+#  define __LEAF
+#  define __LEAF_ATTR
+# endif
+
 /* GCC can always grok prototypes.  For C++ programs we add throw()
    to help it optimize the function calls.  But this works only with
-   gcc 2.8.x and egcs.  */
-# if defined __cplusplus && __GNUC_PREREQ (2,8)
-#  define __THROW	throw ()
+   gcc 2.8.x and egcs.  For gcc 3.2 and up we even mark C functions
+   as non-throwing using a function attribute since programs can use
+   the -fexceptions options for C code as well.  */
+# if !defined __cplusplus && __GNUC_PREREQ (3, 3)
+#  define __THROW	__attribute__ ((__nothrow__ __LEAF))
+#  define __THROWNL	__attribute__ ((__nothrow__))
+#  define __NTH(fct)	__attribute__ ((__nothrow__ __LEAF)) fct
 # else
-#  define __THROW
+#  if defined __cplusplus && __GNUC_PREREQ (2,8)
+#   define __THROW	throw ()
+#   define __THROWNL	throw ()
+#   define __NTH(fct)	__LEAF_ATTR fct throw ()
+#  else
+#   define __THROW
+#   define __THROWNL
+#   define __NTH(fct)	fct
+#  endif
 # endif
-# define __P(args)	args __THROW
-/* This macro will be used for functions which might take C++ callback
-   functions.  */
-# define __PMT(args)	args
 
 #else	/* Not GCC.  */
 
 # define __inline		/* No inline functions.  */
 
 # define __THROW
-# define __P(args)	args
-# define __PMT(args)	args
-
-# define __const	const
-# define __signed	signed
-# define __volatile	volatile
+# define __THROWNL
+# define __NTH(fct)	fct
 
 #endif	/* GCC.  */
 
+/* These two macros are not used in glibc anymore.  They are kept here
+   only because some other projects expect the macros to be defined.  */
+#define __P(args)	args
+#define __PMT(args)	args
+
 /* For these things, GCC behaves the ANSI way normally,
    and the non-ANSI way under -traditional.  */
 
@@ -118,6 +136,23 @@
 #endif
 
 
+/* Fortify support.  */
+#define __bos(ptr) __builtin_object_size (ptr, __USE_FORTIFY_LEVEL > 1)
+#define __bos0(ptr) __builtin_object_size (ptr, 0)
+#define __fortify_function __extern_always_inline __attribute_artificial__
+
+#if __GNUC_PREREQ (4,3)
+# define __warndecl(name, msg) \
+  extern void name (void) __attribute__((__warning__ (msg)))
+# define __warnattr(msg) __attribute__((__warning__ (msg)))
+# define __errordecl(name, msg) \
+  extern void name (void) __attribute__((__error__ (msg)))
+#else
+# define __warndecl(name, msg) extern void name (void)
+# define __warnattr(msg)
+# define __errordecl(name, msg) extern void name (void)
+#endif
+
 /* Support for flexible arrays.  */
 #if __GNUC_PREREQ (2,97)
 /* GCC 2.97 supports C99 flexible array members.  */
@@ -149,6 +184,17 @@
 #if defined __GNUC__ && __GNUC__ >= 2
 
 # define __REDIRECT(name, proto, alias) name proto __asm__ (__ASMNAME (#alias))
+# ifdef __cplusplus
+#  define __REDIRECT_NTH(name, proto, alias) \
+     name proto __THROW __asm__ (__ASMNAME (#alias))
+#  define __REDIRECT_NTHNL(name, proto, alias) \
+     name proto __THROWNL __asm__ (__ASMNAME (#alias))
+# else
+#  define __REDIRECT_NTH(name, proto, alias) \
+     name proto __asm__ (__ASMNAME (#alias)) __THROW
+#  define __REDIRECT_NTHNL(name, proto, alias) \
+     name proto __asm__ (__ASMNAME (#alias)) __THROWNL
+# endif
 # define __ASMNAME(cname)  __ASMNAME2 (__USER_LABEL_PREFIX__, cname)
 # define __ASMNAME2(prefix, cname) __STRING (prefix) cname
 
@@ -176,6 +222,15 @@
 # define __attribute_malloc__ /* Ignore */
 #endif
 
+/* Tell the compiler which arguments to an allocation function
+   indicate the size of the allocation.  */
+#if __GNUC_PREREQ (4, 3)
+# define __attribute_alloc_size__(params) \
+  __attribute__ ((__alloc_size__ params))
+#else
+# define __attribute_alloc_size__(params) /* Ignore.  */
+#endif
+
 /* At some point during the gcc 2.96 development the `pure' attribute
    for functions was introduced.  We don't want to use it unconditionally
    (although this would be possible) since it generates warnings.  */
@@ -185,6 +240,13 @@
 # define __attribute_pure__ /* Ignore */
 #endif
 
+/* This declaration tells the compiler that the value is constant.  */
+#if __GNUC_PREREQ (2,5)
+# define __attribute_const__ __attribute__ ((__const__))
+#else
+# define __attribute_const__ /* Ignore */
+#endif
+
 /* At some point during the gcc 3.1 development the `used' attribute
    for functions was introduced.  We don't want to use it unconditionally
    (although this would be possible) since it generates warnings.  */
@@ -226,6 +288,28 @@
 # define __attribute_format_strfmon__(a,b) /* Ignore */
 #endif
 
+/* The nonull function attribute allows to mark pointer parameters which
+   must not be NULL.  */
+#if __GNUC_PREREQ (3,3)
+# define __nonnull(params) __attribute__ ((__nonnull__ params))
+#else
+# define __nonnull(params)
+#endif
+
+/* If fortification mode, we warn about unused results of certain
+   function calls which can lead to problems.  */
+#if __GNUC_PREREQ (3,4)
+# define __attribute_warn_unused_result__ \
+   __attribute__ ((__warn_unused_result__))
+# if __USE_FORTIFY_LEVEL > 0
+#  define __wur __attribute_warn_unused_result__
+# endif
+#else
+# define __attribute_warn_unused_result__ /* empty */
+#endif
+#ifndef __wur
+# define __wur /* Ignore */
+#endif
 
 /* Forces a function to be always inlined.  */
 #if __GNUC_PREREQ (3,2)
@@ -242,10 +326,12 @@
 # define __attribute_artificial__ /* Ignore */
 #endif
 
-/* GCC 4.3 and above with -std=c99 or -std=gnu99 implements ISO C99
-   inline semantics, unless -fgnu89-inline is used.  */
-#if !defined __cplusplus || __GNUC_PREREQ (4,3)
-# if defined __GNUC_STDC_INLINE__ || defined __cplusplus
+#ifdef __GNUC__
+/* One of these will be defined if the __gnu_inline__ attribute is
+   available.  In C++, __GNUC_GNU_INLINE__ will be defined even though
+   __inline does not use the GNU inlining rules.  If neither macro is
+   defined, this version of GCC only supports GNU inline semantics. */
+# if defined __GNUC_STDC_INLINE__ || defined __GNUC_GNU_INLINE__
 #  define __extern_inline extern __inline __attribute__ ((__gnu_inline__))
 #  define __extern_always_inline \
   extern __always_inline __attribute__ ((__gnu_inline__))
@@ -253,10 +339,17 @@
 #  define __extern_inline extern __inline
 #  define __extern_always_inline extern __always_inline
 # endif
-#else
-#  define __extern_inline extern __inline
+#else /* Not GCC.  */
+# define __extern_inline  /* Ignore */
+# define __extern_always_inline /* Ignore */
 #endif
 
+/* GCC 4.3 and above allow passing all anonymous arguments of an
+   __extern_always_inline function to some other vararg function.  */
+#if __GNUC_PREREQ (4,3)
+# define __va_arg_pack() __builtin_va_arg_pack ()
+# define __va_arg_pack_len() __builtin_va_arg_pack_len ()
+#endif
 
 /* It is possible to compile containing GCC extensions even if GCC is
    run in pedantic mode if the uses are carefully marked using the
@@ -289,4 +382,56 @@
 # endif
 #endif
 
+#if __GNUC__ >= 3
+# define __glibc_unlikely(cond)	__builtin_expect ((cond), 0)
+# define __glibc_likely(cond)	__builtin_expect ((cond), 1)
+#else
+# define __glibc_unlikely(cond)	(cond)
+# define __glibc_likely(cond)	(cond)
+#endif
+
+#if (!defined _Noreturn \
+     && (defined __STDC_VERSION__ ? __STDC_VERSION__ : 0) < 201112 \
+     &&  !__GNUC_PREREQ (4,7))
+# if __GNUC_PREREQ (2,8)
+#  define _Noreturn __attribute__ ((__noreturn__))
+# else
+#  define _Noreturn
+# endif
+#endif
+
+#include <bits/wordsize.h>
+
+#if defined __LONG_DOUBLE_MATH_OPTIONAL && defined __NO_LONG_DOUBLE_MATH
+# define __LDBL_COMPAT 1
+# ifdef __REDIRECT
+#  define __LDBL_REDIR1(name, proto, alias) __REDIRECT (name, proto, alias)
+#  define __LDBL_REDIR(name, proto) \
+  __LDBL_REDIR1 (name, proto, __nldbl_##name)
+#  define __LDBL_REDIR1_NTH(name, proto, alias) __REDIRECT_NTH (name, proto, alias)
+#  define __LDBL_REDIR_NTH(name, proto) \
+  __LDBL_REDIR1_NTH (name, proto, __nldbl_##name)
+#  define __LDBL_REDIR1_DECL(name, alias) \
+  extern __typeof (name) name __asm (__ASMNAME (#alias));
+#  define __LDBL_REDIR_DECL(name) \
+  extern __typeof (name) name __asm (__ASMNAME ("__nldbl_" #name));
+#  define __REDIRECT_LDBL(name, proto, alias) \
+  __LDBL_REDIR1 (name, proto, __nldbl_##alias)
+#  define __REDIRECT_NTH_LDBL(name, proto, alias) \
+  __LDBL_REDIR1_NTH (name, proto, __nldbl_##alias)
+# endif
+#endif
+#if !defined __LDBL_COMPAT || !defined __REDIRECT
+# define __LDBL_REDIR1(name, proto, alias) name proto
+# define __LDBL_REDIR(name, proto) name proto
+# define __LDBL_REDIR1_NTH(name, proto, alias) name proto __THROW
+# define __LDBL_REDIR_NTH(name, proto) name proto __THROW
+# define __LDBL_REDIR_DECL(name)
+# ifdef __REDIRECT
+#  define __REDIRECT_LDBL(name, proto, alias) __REDIRECT (name, proto, alias)
+#  define __REDIRECT_NTH_LDBL(name, proto, alias) \
+  __REDIRECT_NTH (name, proto, alias)
+# endif
+#endif
+
 #endif	 /* sys/cdefs.h */
diff --git a/src/system/libroot/posix/glibc/include/not-cancel.h b/src/system/libroot/posix/glibc/include/not-cancel.h
new file mode 100644
index 0000000000..9f634c221d
--- /dev/null
+++ b/src/system/libroot/posix/glibc/include/not-cancel.h
@@ -0,0 +1,54 @@
+/* Uncancelable versions of cancelable interfaces.  Generic version.
+   Copyright (C) 2003-2014 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Ulrich Drepper <drepper@redhat.com>, 2003.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+/* By default we have none.  Map the name to the normal functions.  */
+#define open_not_cancel(name, flags, mode) \
+  open (name, flags, mode)
+#define open_not_cancel_2(name, flags) \
+  open (name, flags)
+#define openat_not_cancel(fd, name, flags, mode) \
+  openat (fd, name, flags, mode)
+#define openat_not_cancel_3(fd, name, flags) \
+  openat (fd, name, flags, 0)
+#define openat64_not_cancel(fd, name, flags, mode) \
+  openat64 (fd, name, flags, mode)
+#define openat64_not_cancel_3(fd, name, flags) \
+  openat64 (fd, name, flags, 0)
+#define close_not_cancel(fd) \
+  close (fd)
+#define close_not_cancel_no_status(fd) \
+  (void) close (fd)
+#define read_not_cancel(fd, buf, n) \
+  read (fd, buf, n)
+#define write_not_cancel(fd, buf, n) \
+  write (fd, buf, n)
+#define writev_not_cancel_no_status(fd, iov, n) \
+  (void) writev (fd, iov, n)
+#define fcntl_not_cancel(fd, cmd, val) \
+  fcntl (fd, cmd, val)
+# define waitpid_not_cancel(pid, stat_loc, options) \
+  waitpid (pid, stat_loc, options)
+#define pause_not_cancel() \
+  pause ()
+#define nanosleep_not_cancel(requested_time, remaining) \
+  nanosleep (requested_time, remaining)
+#define sigsuspend_not_cancel(set) \
+  sigsuspend (set)
+
+#define NO_CANCELLATION 1
diff --git a/src/system/libroot/posix/glibc/include/string.h b/src/system/libroot/posix/glibc/include/string.h
index eb7cf24e8a..fa031be66c 100644
--- a/src/system/libroot/posix/glibc/include/string.h
+++ b/src/system/libroot/posix/glibc/include/string.h
@@ -1,6 +1,7 @@
 #ifndef _LIBC_STRING_H
 #define _LIBC_STRING_H
 
+#define _DEFAULT_SOURCE
 #include_next <string.h>
 
 /* map the internal glibc interface to the public one */
diff --git a/src/system/libroot/posix/glibc/libio/Jamfile b/src/system/libroot/posix/glibc/libio/Jamfile
index 974c934fd4..fcefe8d23d 100644
--- a/src/system/libroot/posix/glibc/libio/Jamfile
+++ b/src/system/libroot/posix/glibc/libio/Jamfile
@@ -94,7 +94,6 @@ for architectureObject in [ MultiArchSubDirSetup ] {
 			iovsprintf.c
 			iovsscanf.c
 			memstream.c
-#			obprintf.c
 			pclose.c
 			peekc.c
 			putc.c
@@ -112,7 +111,6 @@ for architectureObject in [ MultiArchSubDirSetup ] {
 			vsnprintf.c
 
 			# wide character
-
 			fputwc.c
 			fputwc_u.c
 			fwprintf.c
